<?php class WCPS_BulkEditor
{
	var $current_lang;
	var $messages;
	public function __construct()
	{
	}
	public function render_page()
	{
		global $wcps_html_helper, $wcps_product_model,$wcps_wpml_helper;
		$this->messages = array();
		//Save data
		if(isset($_POST['wcps_bulk_edit']) && wp_verify_nonce($_POST['wcps_bulk_edit'], 'wcps_bulk_edit_action'))
		{
			$wpml = $wcps_wpml_helper->wpml_is_active() ? esc_html__('(including translated products)'):"";
			array_push( $this->messages, sprintf(__('%d product(s) have been updated %s !', 'woocommerce-pre-sale'), $wcps_product_model->save_bulk($_POST), $wpml ));
		}
		if ( ! empty( $this->messages ) ) {
				foreach ( $this->messages as $msg )
					echo '<div id="message" class="updated"><p>' . $msg . '</p></div>';
			} ?>
		<div id = "white-box"> 
			<h1 ><?php  esc_html_e('How it works?', 'woocommerce-pre-sale');?></h1>
				<p>
				<?php  esc_html_e('To add a pre-sale or a limited time offer to one or more products/products categories use this page. ', 'woocommerce-pre-sale');?><br/>
				<?php  esc_html_e('If you need to edit a single product, you can do that directly on every single product page using the pre-sale / time offer tab in the "Product Data" Box (Go to "Products" menu voice and choose one product)', 'woocommerce-pre-sale');?>
				</p>
				<div id="spacer"></div>
				
			<h2 ><?php  esc_html_e('Bulk edit pre-sales / time offers', 'woocommerce-pre-sale');?></h2>
			<p> <?php esc_html_e('By this section you can bulk edit products pre-sales / time offers periods. ', 'woocommerce-pre-sale') ?>
				<br/>
				<strong><?php esc_html_e('NOTE: To bulk reset/assign pre-sales / time-offers options to all products, leave "Selects products" and "categories".', 'woocommerce-pre-sale') ?></strong>
			</p>
			<?php $wcps_html_helper->woocommere_bulk_edit(); ?>
		</div>
		<?php 
	}
}?>