<?php 
class WCPS_Finder
{
	public function __construct()
	{
	}
	public function render_page()
	{
		global $wcps_order_model;
		
		$js_options = array(
			 'admin_url' => admin_url("post.php?post="),
			 'orders_list_url' => admin_url("edit.php?post_type=shop_order"),
			 'date_error' =>  esc_html__('Starting date cannot be greater than ending date', 'woocommerce-pre-sale'),
			 'csv_error' => esc_html__('Field separator or Line breaker fields cannot be empty', 'woocommerce-pre-sale'),
			 'statuses_error' => esc_html__('Select at least one status', 'woocommerce-pre-sale'),
			 'column_to_export_error' => esc_html__('Select at least one column to export', 'woocommerce-pre-sale')
		);
		wp_enqueue_script (  'jquery-ui-core'  ) ;
		wp_enqueue_script( 'jquery-ui-progressbar' );
		
		wp_enqueue_style('jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css');
		wp_enqueue_style('wcps-export-tab', WCPS_PLUGIN_PATH.'/css/wcps-admin-finder.css');  
		wp_enqueue_style('datepicker-classic',  WCPS_PLUGIN_PATH.'/css/datepicker/classic.css');   
		wp_enqueue_style('datepicker-date-classic',  WCPS_PLUGIN_PATH.'/css/datepicker/classic.date.css');   
		wp_enqueue_style('datepicker-time-classic',  WCPS_PLUGIN_PATH.'/css/datepicker/classic.time.css');  
		wp_enqueue_style( 'wcps-select2-style',   WCPS_PLUGIN_PATH.'/css/select2.min.css' ); 		
		wp_enqueue_style('jquery-datatable',  WCPS_PLUGIN_PATH.'/css/jquery.dataTables.min.css');
				
		wp_enqueue_script('ui-picker',  WCPS_PLUGIN_PATH.'/js/picker.js');
		wp_enqueue_script('ui-timepicker',  WCPS_PLUGIN_PATH.'/js/picker.date.js');
		wp_enqueue_script('wcps-select2-script', WCPS_PLUGIN_PATH.'/js/select2.min.js', array('jquery') );
		wp_enqueue_script('data-table', WCPS_PLUGIN_PATH.'/js/jquery.dataTables.min.js'); 
		wp_enqueue_script('wcps-customer-autocomplete',  WCPS_PLUGIN_PATH.'/js/wcps-admin-finder-customer-autocomplete.js');
		wp_enqueue_script('wcps-products-categories-autocompplete',  WCPS_PLUGIN_PATH.'/js/wcps-admin-finder-product_and_categories-autocomplete.js');
		
		wp_register_script('wcps-export-tab',  WCPS_PLUGIN_PATH.'/js/wcps-admin-finder.js');
		wp_localize_script('wcps-export-tab', 'wcps', $js_options);
		wp_enqueue_script('wcps-export-tab');
		?>
		<div id = "white-box"> 
			<div id="wcps-order-list">
				<table id="orders-table" class="display" cellspacing="0" width="100%" >
					<thead>
							<tr>
								<th scope="col" class="manage-column column-id" style=""><?php  esc_html_e('Order ID', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-date" style=""><?php  esc_html_e('Order date', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-name" style=""><?php  esc_html_e('Customer name', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-surname" style=""><?php  esc_html_e('Customer surname', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-email" style=""><?php  esc_html_e('Customer email', 'woocommerce-customers-manager');?></th>
							</tr>
					</thead>

					<tfoot>
							<tr>
								<th scope="col" class="manage-column column-id" style=""><?php  esc_html_e('Order ID', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-date" style=""><?php  esc_html_e('Order date', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-name" style=""><?php  esc_html_e('Customer name', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-surname" style=""><?php  esc_html_e('Customer surname', 'woocommerce-customers-manager');?></th>
								<th scope="col" class="manage-column column-email" style=""><?php  esc_html_e('Customer email', 'woocommerce-customers-manager');?></th>
							</tr>
					</tfoot>

					<tbody id="table-body">
					</tbody>
					</table>
			</div>
			<div id="progress-container">
				<h2 id="ajax-progress-title"><?php  esc_html_e('Progress', 'woocommerce-pre-sale');?></h2>
				<div id="ajax-progress"></div>
				<div id="progressbar"></div>
			</div>
			<button class="button" id="reload_button"><?php  esc_html_e('Find more', 'woocommerce-pre-sale');?> </button>
			
			<div id="option-box">
			
				<h2 ><?php  esc_html_e('Finder', 'woocommerce-pre-sale');?></h2>
				<p>
				<?php  esc_html_e('This is the "Finder" page where you can find orders with pre-saled / time offered products. Select the filter you want: ', 'woocommerce-pre-sale');?><br/>
				</p>
					<h4><?php  esc_html_e('Filter by status', 'woocommerce-pre-sale');?></h4>
					<?php $statuses= $wcps_order_model->get_order_statuses(); ?>
					<div id="status-checkbox-box">
						<input type="hidden" id="statuses-version" value="<?php echo $statuses['version']; ?>"></input>
						<?php foreach($statuses['statuses'] as $key_or_slug => $status):
							echo ' <input type="checkbox" class="status-checkbox" value="'.$key_or_slug.'" checked/>'.$status.'<br />';
						endforeach;?>
					</div>
					
									
					<div id="filter-box">
						<h4><?php  esc_html_e('Filter by Customers (you can search typing name, last name or email)', 'woocommerce-pre-sale');?></h4>
						<select class="js-data-customers-ajax" id="customer_ids" multiple='multiple'> 
						</select>
				
				<div id="spacer"></div>
					<select class="" id="customer_product_category_filters_relationship"> 
						<option value="and">AND</option>
						<option value="or">OR</option>
					</select>
					
					
						<h4><?php  esc_html_e('Filter by Products (you can search typing product name, id or sku code)', 'woocommerce-pre-sale');?></h4>
						<select class="js-data-products-ajax" id="product_ids" multiple='multiple'> 
						</select>
						<select class="" id="product_relationship"> 
							<option value="or">OR</option>
							<option value="and">AND</option>
						</select>
						
						<div id="spacer"></div>
						<!--<h4><?php  esc_html_e('Relationship between products and categories filters', 'woocommerce-pre-sale');?></h4>-->
						<select class="" id="product_category_filters_relationship"> 
							<option value="or">OR</option>
							<option value="and">AND</option>
						</select>
						
						<h4><?php  esc_html_e('Filter by Products categories', 'woocommerce-pre-sale');?></h4>
						<select class="js-data-product-categories-ajax" id="category_ids" multiple='multiple'> 
						</select>
						<select class="" id="product_category_relationship"> 
								<option value="or">OR</option>
								<option value="and">AND</option>
						</select>
					</div>
					
					<h4><?php  esc_html_e('Filter by Date', 'woocommerce-pre-sale');?></h4>
					<input class="range_datepicker" type="text" id="picker_start_date" name="start_date" value="" placeholder="<?php esc_html_e('Starting date', 'woocommerce-pre-sale' ); ?>" />
					<input class="range_datepicker" type="text" id="picker_end_date" name="end_date" value="" placeholder="<?php esc_html_e('Ending date', 'woocommerce-pre-sale' ); ?>" />
				
					
				<button class="button" id="start-export-button"><?php  esc_html_e('Find', 'woocommerce-pre-sale');?></button>
			</div>
			
		</div>
		<?php
	}
}
?>