<?php
class WCPS_OrdersTable
{
	public function __construct()
	{
		add_action( 'manage_shop_order_posts_custom_column', array($this, 'manage_presale_column_content'), 10, 2 );
		add_filter( 'manage_edit-shop_order_columns', array($this, 'add_presale_column_head'),15 ); 
		add_action('restrict_manage_posts', array( &$this,'add_presale_select_box_filter'));
		add_filter('parse_query',array( &$this,'filter_query_by_presale'));
		//add_filter( 'woocommerce_shop_order_search_fields', array( &$this, 'woocommerce_shop_order_search_by_id') );
		add_action( 'pre_get_posts', array( &$this, 'woocommerce_shop_order_search_by_id') );
	}
	function woocommerce_shop_order_search_by_id( $query ) 
	{
	  
       if(isset($_GET['wcps_is_search_orders_by_id']))
		{
			$orders_ids = explode(",",$_GET['wcps_order_ids']);
			if($orders_ids != false)
			{
				$query->set('post__in', $orders_ids);
			}
		}
	}
	public function add_presale_column_head($columns)
	 {
		
	   //add column
	   $columns['wpcs-presale'] = wpcs_html_escape_allowing_special_tags(__('Items that were in<br/>Pre-sale / Time offer', 'woocommerce-pre-sale'), false); 
	   $columns['wpcs-presale-still-active'] = wpcs_html_escape_allowing_special_tags(__('#Items still in<br/>Pre-sale / Time offer', 'woocommerce-pre-sale'), false); 
	
	   return $columns;
	}
	public function manage_presale_column_content( $column, $order_id ) 
	{
		global $wcps_order_model;
		if ( $column == 'wpcs-presale' ) 
		{
			echo $wcps_order_model->get_presales_items_num($order_id);

		}
		else if( $column == 'wpcs-presale-still-active')
		{
			echo $wcps_order_model->get_presales_items_still_active_num($order_id);
		}
	}
	public function add_presale_select_box_filter()
	{
		global $typenow;
		global $wp_query;
		if ($typenow=='shop_order') 
		{
			$selected = isset($_GET['wcps_filter_by_presale']) && $_GET['wcps_filter_by_presale'] ? $_GET['wcps_filter_by_presale']:"none";
			?>
			<select name="wcps_filter_by_presale" >
				<option value="all" <?php if($selected == "all") echo 'selected="selected"';?>><?php esc_html_e('Show all orders', 'woocommerce-pre-sale') ?></option>
				<option value="presale-only" <?php if($selected == "presale-only") echo 'selected="selected"';?>><?php esc_html_e('With items that were in pre-sale / time offer', 'woocommerce-pre-sale') ?></option>
			</select>
			<?php
		}
	}
	function filter_query_by_presale($query) 
	{
		global $pagenow,$wcps_order_model;
		$qv = &$query->query_vars;
		if ($pagenow=='edit.php' && 
		    isset($qv['post_type']) && $qv['post_type']=='shop_order' && isset($_GET['wcps_filter_by_presale']) && $_GET['wcps_filter_by_presale'] == 'presale-only') 
		{
			
			if($data = $wcps_order_model->get_orders_with_presales_items())
				 $qv['post__in'] = explode(",", $data->orders_ids); 
		}
		
	}
	
}
?>