<?php 
class WCPS_Product
{
	var $presa_data;
	var $is_presale_active = array();
	var $has_ended;
	var $hide_post_for_not_allowed_user_already_done = false;
	var $check_products_to_show_or_hide_after_presale_already_done = false;
	var $post_to_hide_for_not_allowed_users = array();
	var $expiring_email_already_sent = array();
	public function __construct()
	{
		if(is_admin())
		{
			add_action('wp_ajax_wcps_get_products_list', array(&$this, 'ajax_get_products_partial_list'));
			add_action('wp_ajax_wcps_get_product_categories_list', array(&$this, 'ajax_get_product_categories_partial_list'));
		}
	}
	public function get_variation_complete_name($variation_id, $cart_item = null)
	{
		//$variation = new WC_Product_Variation($variation_id);
		$variation = wc_get_product($variation_id);
		
		$product_name = $variation->get_title()." - ";	
		$attributes_counter = 0;
		foreach($variation->get_variation_attributes( ) as $attribute_name => $value)
		{
			
			if($attributes_counter > 0)
				$product_name .= ", ";
			$meta_key = urldecode( str_replace( 'attribute_', '', $attribute_name ) ); 
			if(isset($cart_item) && isset($cart_item['variation']) && !empty($cart_item['variation']))
					foreach($cart_item['variation'] as $temp_attribute_name => $temp_attribute_value)
						if($temp_attribute_name == "attribute_".$meta_key)
								$value = $temp_attribute_value;
			$product_name .= " ".wc_attribute_label( $meta_key).": ".$value;
			$attributes_counter++;
		}
		return $product_name;
	}
	function get_option($post_id, $product_meta_key, $poduct_sub_key = null)
	{
		$options = get_post_meta($post_id, $product_meta_key); //get_option( '_wcps_data'); 
		$options = isset($options) ? $options: array();
		
		$result = null;
		if(isset($poduct_sub_key))
		{
			if(isset($options[0]) && isset($options[0][$poduct_sub_key]))
				$result = $options[0][$poduct_sub_key];
		}
		else
			$result = isset($options[0]) ? $options[0]  : null;
		return $result;
	}
	//used by bulk editor
	function save_bulk($data)
	{
		global $wpdb,$wcps_wpml_helper;
		$products = array();
		$reset_all = !isset($data['wcps_selected_products']) && !isset($data['wcps_selected_categories']) ? true : false;
		/* wcps_var_dump($data);
		wcps_var_dump($reset_all); */
		 if(isset($data['wcps_selected_categories']))
		 {
			$categories = $data['wcps_selected_categories'];
		    foreach($categories as $category)
		    {
			
				$include_children = false;
				if($data['wcps_cat_assignment_type'] == 'categories_children')
				{
					$include_children = true;
				}				 
				$args = array(
					'posts_per_page'   => -1,
					'offset'           => 0,
					'post_type'        => 'product',
					'post_status'      => 'any',//'publish',
					'suppress_filters' => true,
					'fields' => 'ids',
					'tax_query' => array(
						array(
						'taxonomy' => 'product_cat',
						'field' => 'term_id',
						'include_children' => $include_children,
						'terms' => $category //implode(",",$categories_ids)
					) )
				);
				$products = get_posts( $args );
		    } 
	    }
			
		if(isset($data['wcps_selected_products']))
		{
			$products = array_merge($products, $data['wcps_selected_products']);
		}
		////WPML --> 'suppress_filters' = false already returs translated ids
		$translation = $wcps_wpml_helper->get_translated_id($products);
		if(!$reset_all  && $wcps_wpml_helper->wpml_is_active() && !empty($translation))
		{
			$products = $translation;
		} 	
		
		if($reset_all)
		{
				$args = array(
					'posts_per_page'   => -1,
					'offset'           => 0,
					'post_type'        => 'product',
					'post_status'      => 'any',//'publish',
					'suppress_filters' => true,
					'fields' => 'ids'
				);
				$products = get_posts( $args );
		}
		
		 foreach($products as $post_id)
			$this->save_all_options($post_id, $data);
		
		
		//bulk query
		//Create if an entry doesn't exist, otherwise update: REPLACE INTO table SET id = 42, foo = 'bar';
		$active = isset($data['wcps_data']['presale_active']) ? 'yes':'no';
	
		
		return count($products);
	}
	function save_all_options($product_id, $data)
	{
		$data['wcps_shop_page_message'] = isset($data['wcps_shop_page_message']) ? $data['wcps_shop_page_message'] : "";
		$data['wcps_expired_shop_page_message'] = isset($data['wcps_expired_shop_page_message']) ? $data['wcps_expired_shop_page_message'] : "";
		$data['wcps_product_page_message'] = isset($data['wcps_product_page_message']) ? $data['wcps_product_page_message'] : "";
		$data['wcps_expired_product_page_message'] = isset($data['wcps_expired_product_page_message']) ? $data['wcps_expired_product_page_message'] : "";
		$data['wcps_add_to_cart_text'] = isset($data['wcps_add_to_cart_text']) ? $data['wcps_add_to_cart_text'] : "";
		$data['wcps_badge_text_next_to_product'] = isset($data['wcps_badge_text_next_to_product']) ? $data['wcps_badge_text_next_to_product'] : "";
		$data['wcps_sale_badge_text'] = isset($data['wcps_sale_badge_text']) ? $data['wcps_sale_badge_text'] : "";
		
		$active = isset($data['wcps_data']['presale_active']) ? 'yes':'no';
		$this->save_option( $product_id, 'wcps_data', $data['wcps_data']);
		$this->save_option( $product_id, 'wcps_presale_active', $active);
		$this->set_expired_value( $product_id, false); 
		//Message are stored in separated meta values due to WPML compability
		$this->save_option( $product_id, 'wcps_shop_page_message', $data['wcps_shop_page_message']); 
		$this->save_option( $product_id, 'wcps_expired_shop_page_message', $data['wcps_expired_shop_page_message']); 
		$this->save_option( $product_id, 'wcps_product_page_message', $data['wcps_product_page_message']);		
		$this->save_option( $product_id, 'wcps_expired_product_page_message', $data['wcps_expired_product_page_message']);		
		$this->save_option( $product_id, 'wcps_add_to_cart_text', $data['wcps_add_to_cart_text']);	
		//badges
		$this->save_option( $product_id, 'wcps_badge_text_next_to_product', $data['wcps_badge_text_next_to_product']);
		$this->save_option( $product_id, 'wcps_sale_badge_text', $data['wcps_sale_badge_text']);
	}
	public function get_selectable_post_statuses_query_string()
	{
		return "'publish','draft'";
	}
	function set_expired_value( $product_id, $value)
	{
		if($value == true  && !is_admin())
		{
			//notification check
			$data = $this->get_option($product_id, 'wcps_data');
			if( !$this->is_expired($product_id) && isset($data['notify_to_admin_if_a_product_expires']) && $data['presale_active'])
				$this->send_expiration_email($data, $product_id);
		}
		$this->save_option( $product_id, 'wcps_is_expired', $value);
	}
	function send_expiration_email($data, $product_id)
	{
		global $wcps_email_helper;
		if(isset($this->expiring_email_already_sent[$product_id]))
			return;
		$this->expiring_email_already_sent[$product_id] = true;
		$recipients = isset($data['notifification_expired_product_recipients']) && !empty($data['notifification_expired_product_recipients']) ? $data['notifification_expired_product_recipients']: get_bloginfo('admin_email');
		//Trigger notification email
		//For each products the system sends an email. Make it cumulative?
		$wcps_email_helper->trigger($recipients,$product_id);
		//wcps_var_dump($recipients);
	}
	function is_expired($product_id)
	{
		$data = $this->get_option($product_id, 'wcps_data');
		$is_active = isset($data['presale_active']) ? true : false;
		
		return $this->get_option($product_id, 'wcps_is_expired') != null && $is_active ? $this->get_option($product_id, 'wcps_is_expired') : false;
	}
	function if_before_start_date_can_be_purchased($product_id)
	{
		$presale_data = $this->get_presale_data($product_id, true);
		if(!isset($presale_data['data']))
			return true;
		$is_active = isset($presale_data['data']['presale_active']) ? true : false;
		if($is_active)
		{
			$result = $this->check_activation_data($presale_data['data'], $product_id);
			
			$is_active = $result['is_active'];
			if(!$result['is_period_started'] && isset($presale_data['data']['unpurchasable_until_start_date']) && $presale_data['data']['unpurchasable_until_start_date'] == true)
				return false;
			
		}
		return true;
	}
	function save_option($product_id, $option_name, $data)
	{
		//update translation too?
		update_post_meta($product_id,  $option_name, $data);
	}
	public function ajax_get_products_partial_list()
	{
		 $products = $this->get_product_list($_GET['product']);
		 echo json_encode( $products);
		 wp_die();
	}
	public function ajax_get_product_categories_partial_list()
	{
		 $product_categories = $this->get_product_category_list($_GET['product_category']);
		 echo json_encode( $product_categories);
		 wp_die();
	}
	public function get_product_ids_with_presale_active()
	{
		/* global $wpdb;
		$query ="SELECT products.ID as id, products.post_title as product_name, product_meta.meta_value as product_sku
							 FROM {$wpdb->posts} AS products
							 LEFT JOIN {$wpdb->postmeta} AS product_meta ON product_meta.post_id = products.ID
							 WHERE product_meta.meta_key = 'wcps_presale_active'
							 AND   product_meta.meta_value = 'yes'
							";
		$result = $wpdb->get_results($query ) ;
		return $result; */
		global $wpdb;
		$query = "SELECT products.id, product_presale_data.meta_value AS presale_data
				  FROM {$wpdb->posts} AS products
				  INNER JOIN {$wpdb->postmeta} AS product_meta ON product_meta.post_id = products.id
				  INNER JOIN {$wpdb->postmeta} AS product_presale_data ON product_presale_data.post_id = products.id
				  WHERE product_meta.meta_value = 'yes'
				  AND products.post_status IN({$this->get_selectable_post_statuses_query_string()})
				  AND product_meta.meta_key = 'wcps_presale_active' 
				  AND product_presale_data.meta_key = 'wcps_data' ";
		//$products_ids = $wpdb->get_col($query);
		$products = $wpdb->get_results($query);
		return $products;
	}
	public function hide_product_for_non_allowed_users()
	{
		if( $this->hide_post_for_not_allowed_user_already_done)
			return $this->post_to_hide_for_not_allowed_users;
		
		$this->hide_post_for_not_allowed_user_already_done = true;
		$products = $this->get_product_ids_with_presale_active();
		$ids_to_filter = array();
		/* $is_logged = is_user_logged_in();
		$current_user = $is_logged ? wp_get_current_user() : false;
		$current_user_roles = $is_logged ? $current_user->roles : array(); */
					
		
		if(isset($products) && !empty($products))
		{
			$counter = 0;
			foreach($products as $product)
			{
				//wcps_var_dump(++$counter);
				$presale_data = $this->get_presale_data($product->id, true);
				$result = $this->check_activation_data($presale_data['data'], $product->id);
				if($result['is_active'])
				{
					$product_meta = unserialize($product->presale_data);
					
					/* if(isset($product_meta['allowed_roles']) && is_array($product_meta['allowed_roles']) && !empty($product_meta['allowed_roles']) &&
					  (!$is_logged || empty(array_intersect($product_meta['allowed_roles'],$current_user_roles))) && !isset( $product_meta['visible_for_not_allowed_roles']) ) */
					 if(!$this->user_belong_to_allowed_roles($product_meta)/*  && !isset( $product_meta['visible_for_not_allowed_roles']) */) 
					  
					  {
						  $ids_to_filter[] = $product->id;
					  }
				}
			}
		}
		$this->post_to_hide_for_not_allowed_users = $ids_to_filter;
		return $ids_to_filter ;
	}
	public function user_belong_to_allowed_roles($presale_data)
	{
		$is_logged = is_user_logged_in();
		$current_user = $is_logged ? wp_get_current_user() : false;
		$current_user_roles = $is_logged ? $current_user->roles : array();
		if(isset($presale_data['allowed_roles']) && is_array($presale_data['allowed_roles']) && !empty($presale_data['allowed_roles']) &&
		  (!$is_logged || empty(array_intersect($presale_data['allowed_roles'],$current_user_roles))) )
		  {
			 return false;
		  }
		 
		return true;
	}
	public function get_product_list($search_string = null, $with_presale_active = false)
	{
		global $wpdb, $wcps_wpml_helper;
		$additional_join = "  ";
		$additional_where = "  ";
		if($with_presale_active)
		{
			$additional_join = " INNER JOIN {$wpdb->postmeta} AS presale_meta ON presale_meta.post_id = products.ID ";
			$additional_where = " AND presale_meta.meta_key = 'wcps_presale_active' 
								  AND presale_meta.meta_value = 'yes'  ";
		}
		 $query_string = "SELECT products.ID as id, products.post_title as product_name, product_meta.meta_value as product_sku
							 FROM {$wpdb->posts} AS products
							 LEFT JOIN {$wpdb->postmeta} AS product_meta ON product_meta.post_id = products.ID AND product_meta.meta_key = '_sku'".
							 $additional_join." 
							 WHERE products.post_type = 'product'
							 AND products.post_status IN({$this->get_selectable_post_statuses_query_string()})
							";
		if($search_string)
				$query_string .=  " AND ( products.post_title LIKE '%{$search_string}%' OR product_meta.meta_value LIKE '%{$search_string}%' OR products.ID LIKE '%{$search_string}%' ) 
								    ";
		
		$query_string .= $additional_where;
		$query_string .=  " AND products.post_type ='product' GROUP BY products.ID ";
		$result = $wpdb->get_results($query_string ) ;
		//wcps_var_dump($query_string);
		//WPML
		if($wcps_wpml_helper->wpml_is_active())
		{
			$result = $wcps_wpml_helper->remove_translated_id($result);
		}
		
		return $result;
	}
	public function get_product_category_list($search_string = null)
	{
		 global $wpdb, $wcps_wpml_helper;
		  $query_string = "SELECT product_categories.term_id as id, product_categories.name as category_name
							 FROM {$wpdb->terms} AS product_categories
							 LEFT JOIN {$wpdb->term_taxonomy} AS tax ON tax.term_id = product_categories.term_id 							 						 	 
							 WHERE tax.taxonomy = 'product_cat' 
							 AND product_categories.slug <> 'uncategorized' 
							";
		 if($search_string)
					$query_string .=  " AND ( product_categories.name LIKE '%{$search_string}%' )";
			
		$query_string .=  " GROUP BY product_categories.term_id ";
		$result = $wpdb->get_results($query_string ) ;
		
		//WPML
		if($wcps_wpml_helper->wpml_is_active())
		{
			$result = $wcps_wpml_helper->remove_translated_id($result, 'product_cat');
		} 
		
		return $result;
	}
	//$status -  The post status publish|pending|draft|private|static|object|attachment|inherit|future|trash.
	public function change_status($post_id, $status = 'draft')
	{
		global $wcps_option_model, $wpdb;
		$current_post = array();
		$current_post['ID'] = $post_id;
		$current_post['post_status'] = $status;
		if($status == 'draft' && $wcps_option_model->get_option('expired_product_still_visible'))
			$current_post['post_status'] = 'publish';
		
		
		//too slow
		//wp_update_post($current_post);
		if(version_compare( WC_VERSION, '2.7', '<' ))
			$wpdb->update( $wpdb->posts, array( 'post_status' => $current_post['post_status'] ), array( 'ID' => $current_post['ID'] ) );
		else 
		{	
			$product = wc_get_product($post_id);
			if(isset($product ))
			{
				$product->set_status($current_post['post_status']);
				$product->save();
			}
		}
		
		if($status == 'draft')
			$this->set_expired_value( $post_id, true);
		else 
			$this->set_expired_value( $post_id, false);
	}
	public function change_bulk_status($products)
	{
		if(empty($products))
			return;
		
		global $wpdb;

		foreach($products as $status => $products_array)
		{
			if(!empty($products_array))
			{
				$query = "UPDATE {$wpdb->posts} 
						  SET post_status = '{$status}' 
						  WHERE ID IN('".implode("','",  $products_array)."')";
				$results = $wpdb->get_results($query);
				//wcps_var_dump($status);
			}
		}
	}
	//Returns number of product sold during presale
	public function get_total_sales($product_id)
	{
		global $wcps_wpml_helper;
		$product_ids = array($product_id);
		$total_sales = 0;
		
		
		$product_id = $wcps_wpml_helper->get_main_id($product_id);
		$total_sales = get_post_meta($product_id, 'wcps_total_presales');
		$total_sales = isset($total_sales) && isset($total_sales[0]) ? $total_sales[0] : 0;
		
		/*  if($wcps_wpml_helper->wpml_is_active())
			$product_ids =  $wcps_wpml_helper->get_translated_id($product_ids);
		
		foreach($product_ids as $id)
		{
			$result = get_post_meta($id, 'wcps_total_presales'); //-->wcps_total_presales
			$total_sales += isset($result[0]) ? $result[0] : 0;
		}  */
	
		
		return $total_sales;
	}
	//Returns number of product sold all time
	public function get_all_time_total_sales($product_id)
	{
		global $wcps_wpml_helper;
		$product_ids = array($product_id);
		$total_sales = 0;
		
		
		$product_id = $wcps_wpml_helper->get_main_id($product_id);
		$total_sales = get_post_meta($product_id, 'total_sales');
		$total_sales = isset($total_sales) && isset($total_sales[0]) ? $total_sales[0] : 0;
		
		/*  if($wcps_wpml_helper->wpml_is_active())
			$product_ids =  $wcps_wpml_helper->get_translated_id($product_ids);
		
		foreach($product_ids as $id)
		{
			$result = get_post_meta($id, 'wcps_total_presales'); //-->wcps_total_presales
			$total_sales += isset($result[0]) ? $result[0] : 0;
		}  */
	
		
		return $total_sales;
	}
	public function update_total_presales($product_id, $quantity, $absolute_value = false, $reduce = false)
	{
		 global $wcps_wpml_helper;
		 $old = 0;
		 $product_id = $wcps_wpml_helper->get_main_id($product_id);
		 if(!$absolute_value)
		 {
			$old = $this->get_total_sales($product_id);
		 }
		$product_ids = array($product_id);
		if($wcps_wpml_helper->wpml_is_active())
			$product_ids =  $wcps_wpml_helper->get_translated_id($product_ids);
		
		foreach($product_ids as $id)
		{
			if($reduce)
				update_post_meta($id, 'wcps_total_presales', $old-$quantity);
			else
				update_post_meta($id, 'wcps_total_presales', $quantity+$old);
		}
	}
	public function get_presale_data($product_id, $skip_messages = false)
	{
		$wcps_shop_page_message = '';
		$wcps_product_page_message = '';
		if(!isset($this->presa_data) || $this->presa_data['id'] != $product_id)
		{
			$this->is_presale_active[$product_id] = null;
			$data = $this->get_option($product_id, 'wcps_data');
			
			//Message are stored in separated meta values due to WPML compability:
			//wcps_data meta field can be copied from original language, message can be translated separately
			if($skip_messages)
			{
				$wcps_shop_page_message = $this->get_option($product_id, 'wcps_shop_page_message');
				$wcps_product_page_message  = $this->get_option($product_id, 'wcps_product_page_message');
			}
			$this->presa_data = array('id' => $product_id, 'is_expired' => $this->is_expired($product_id), 'data' => $data, 'shop_page_message' =>  $wcps_shop_page_message, 'product_page_message' => $wcps_product_page_message);
		}
		return $this->presa_data;
	}
	public function get_threshold($product_id)
	{
		$presale_data = $this->get_presale_data($product_id, true);
		return isset($presale_data['data']['threshold']) ? (int)$presale_data['data']['threshold'] : 0;
	}
	public function get_presale_price_if_any($product_id, $price, $return_old_price_if_no_presale = true)
	{
		$presale_data = $this->get_presale_data($product_id, true);
		//$is_deposit_active = isset($presale_data['data']['deposit_managment_active']) && $presale_data['data']['deposit_managment_active'] ? true:false;
		$original_price = $price;
		$price = $return_old_price_if_no_presale ? $price : null;
		if(isset($presale_data['data']))
		{
			$options = $presale_data['data'];
			$presale_period_is_active = $this->is_presale_active($product_id);
			if($presale_period_is_active && isset($options['pricing_type']))
			{
				//Price
				if($options['pricing_type'] == 'perc')
					$price = $original_price * ($options['price_value']/100);
				elseif($options['pricing_type'] == 'abs')
					$price = $options['price_value'];
			}
			/* elseif(!$presale_period_is_active && $is_deposit_active)
			{
				global $wcps_customer_model;
				$quantity_left = $wcps_customer_model->has_a_deposit_for_product($product_id);
				$cart = WC()->cart;		
				if($cart)
					foreach($cart->cart_contents as $cart_item_key => $item)
					{
						if($item['product_id'] == $product_id)
						{
							$quantity_left -= $item['quantity'];						
						}
					}
				
				if($quantity_left > 0)
				{
					if($options['pricing_type'] == 'perc')
						$price = $price * ( 1 - ($options['price_value']/100));
					elseif($options['pricing_type'] == 'abs')
						$price = $price - $options['price_value'];
						
					if($price < 0 )
						$price = 0;
				}
			} */
		}
		return $price;
	}
	public function customer_can_purchase_product($product_id, $variation_id = 0, $quantity = 0, $absolute_quantity = true)
	{
		global $wcps_customer_model;
		$presale_data = $this->get_presale_data($product_id, true);
		$is_presale_system_active = isset($presale_data['data']['presale_active']) ? $presale_data['data']['presale_active'] : false;
		$result_data = array('result' => true, 'is_presale_system_active'=>$is_presale_system_active, 'messages' => array(), 'is_virtual'=> false, 'is_presale' => false, 'is_deposit_active'=>false, 'product_id' => $product_id, 'variation_id' => $variation_id, 'cart_item_key'=>null, 'quantity' => $quantity);
		$result_data['is_deposit_active'] = isset($presale_data['data']['deposit_managment_active']) && $presale_data['data']['deposit_managment_active'] ? true : $result_data['is_deposit_active'];
		
		//Product has expired
		if($presale_data['is_expired'] || !$this->if_before_start_date_can_be_purchased($product_id))
		{
			$result_data['result'] = false;
			//$product = new WC_Product($product_id);
			$product = wc_get_product($product_id);
			$result_data['messages'][] = sprintf(esc_html__('%s cannot be purchased. It has been removed from cart, please refresh the page.','woocommerce-pre-sale'), $product->get_title());
		}
		//Pre-sale / Time offer period is active
		elseif($this->is_presale_active($product_id))
		{
			$result_data['is_presale'] = true;			
			$result_data['is_virtual'] = isset($presale_data['data']['set_as_virtual']) ? true:false;			
			//$result_data['result'] = true;
			$purchase_limit = isset($presale_data['data']['purchase_limit']) ? $presale_data['data']['purchase_limit'] : 'no_limits';
			$end_period_strategy = isset($presale_data['data']['end_period_strategy']) ? $presale_data['data']['end_period_strategy'] : 'publish';
			$threshold = isset($presale_data['data']['threshold']) ? (int)$presale_data['data']['threshold'] : 0;
			$current_item_total_sales = $this->get_total_sales($product_id );
			$quantity_in_cart = 0;
			
			//cart item
			$cart = WC()->cart;			
			foreach($cart->cart_contents as $cart_item_key => $item)
			{
				//wcps_var_dump($item);
				if($item['product_id'] == $product_id)
				{
					if($item['variation_id'] == 0 || $item['variation_id'] == $variation_id)
						$result_data['cart_item_key'] = $cart_item_key;
						
					$item_name = $item['data']->get_title();
				}
			}
				
			//roles
			if(isset($presale_data['data']['allowed_roles']) && is_array($presale_data['data']['allowed_roles']) && !empty($presale_data['data']['allowed_roles']))
			{
				$is_logged = is_user_logged_in();
				$current_user = $is_logged ? wp_get_current_user() : false;
				$current_user_roles = $is_logged ? $current_user->roles : array();
		
				if(!$is_logged || empty(array_intersect($presale_data['data']['allowed_roles'],$current_user_roles)))
				{
					$result_data['result'] = false;
					$name_to_output = isset($item_name) ? $item_name  : esc_html__('the selected product','woocommerce-pre-sale');
					$result_data['messages'][] = sprintf( esc_html__('You have not sufficient permissions to buy %s. Remove from cart.','woocommerce-pre-sale'), $name_to_output);
				}
			}
			
			//Deposit
			//No need check if the user is logged and if he already have purchased the product
			/* if($result_data['is_deposit_active'])
			{
				$already_purchased_num = $wcps_customer_model->get_num_purchased_per_item($product_id );
				if($already_purchased_num < 0)
				{
					$result_data['result'] = false;
					$name_to_output = isset($item_name) ? $item_name  : esc_html__('the selected product','woocommerce-pre-sale');
					$result_data['messages'][] = sprintf( esc_html__('You must be logged to buy %s','woocommerce-pre-sale'), $name_to_output);
				}
			} */
			
			//If end strategy dependent on "Thereshold", Item quantity added to cart is checked to avoid purchasing
			//of more item that the threshold limit value.
			//wcps_var_dump($end_period_strategy." ".$quantity." ".$threshold);	
			if($end_period_strategy == 'special_price_before_threshold'/* $end_period_strategy != 'publish' && $end_period_strategy != 'unpublish' */)
			{
				if($current_item_total_sales + $quantity_in_cart + $quantity > $threshold)
				{
					$result_data['result'] = false;
					$name_to_output = isset($item_name) ? esc_html__('of ','woocommerce-pre-sale').$item_name : esc_html__('the selected product','woocommerce-pre-sale');
					$result_data['messages'][] = sprintf( esc_html__('You cannot buy %d for product %s.','woocommerce-pre-sale'), $quantity, $name_to_output);
				}
			}
			
			if($purchase_limit == 'item_per_customer' || $purchase_limit == 'item_per_order' )
			{
				$max_quantity = isset($presale_data['data']['purchase_limit_quantity']) ? $presale_data['data']['purchase_limit_quantity'] : 0;
				$quantity_in_cart += $quantity;				
				
				
					if($quantity_in_cart > $max_quantity)
					{
						$result_data['result'] = false;
						$name_to_output = isset($item_name) ? esc_html__('of ','woocommerce-pre-sale').$item_name : '';
						$result_data['messages'][] = sprintf( esc_html__('You cannot buy more than %s %s. Please adjust quantity value.','woocommerce-pre-sale'), $max_quantity, $name_to_output);
					}
					else if($purchase_limit == 'item_per_customer')
					{
						
						$already_purchased_num = $wcps_customer_model->get_num_purchased_per_item($product_id );
					
						if($already_purchased_num < 0)
						{
							$result_data['result'] = false;
							$name_to_output = isset($item_name) ? $item_name  : esc_html__('the selected product','woocommerce-pre-sale');
							$result_data['messages'][] = sprintf( esc_html__('You must be logged to buy %s','woocommerce-pre-sale'), $name_to_output);
						}
						else if($already_purchased_num + $quantity_in_cart > $max_quantity)
						{
							
							$result_data['result'] = false;
							$name_to_output = isset($item_name) ? esc_html__('of ','woocommerce-pre-sale').$item_name : '';
							$result_data['messages'][] = sprintf( esc_html__('Max purchase limit per user has been reached. You have already bought %d %s','woocommerce-pre-sale'), $already_purchased_num, $name_to_output);
						}								
					}
									
				
			}
		}
		//Period is ended, check deposit restrictions
		/*elseif($is_presale_system_active && $result_data['is_deposit_active'])
		{
			$deposit_quantity = $wcps_customer_model->has_a_deposit_for_product($product_id, $variation_id);
				
			if(!$absolute_quantity)
			{
				$cart = WC()->cart;			
				foreach($cart->cart_contents as $cart_item_key => $item)
					if($item['product_id'] == $product_id && ($item['variation_id'] == 0 || $item['variation_id'] == $variation_id))
						$quantity += $item['quantity'];	
				
			}
			 if(isset($presale_data['data']['deposit_managment_only_presalers']) && $presale_data['data']['deposit_managment_only_presalers'])
			{
				if($deposit_quantity < 0 )
				{
					$result_data['result'] = false;
					$result_data['messages'][] = esc_html__('Selected item cannot be purchased.','woocommerce-pre-sale');
				}
			} 
			if(isset($presale_data['data']['deposit_managment_quantity_restriction']) && $presale_data['data']['deposit_managment_quantity_restriction'])
			{
				if($deposit_quantity < 1 || $quantity > $deposit_quantity)
				{
					$result_data['result'] = false;
					$result_data['messages'][] = esc_html__('Max purchase limit has been reached.','woocommerce-pre-sale');
				}
			}
		}*/
		elseif($is_presale_system_active && $this->has_ended)
		{
			$presale_buy_quantity = $wcps_customer_model->get_num_purchased_per_item($product_id);
			if(isset($presale_data['data']['only_presalers_can_buy']) && $presale_data['data']['only_presalers_can_buy'] && $presale_buy_quantity < 1)
			{
				$result_data['result'] = false;
				$result_data['messages'][] = esc_html__('Selected item cannot be purchased.','woocommerce-pre-sale');	
			}
		}
		return $result_data;
	}
	public function validate_current_customer_cart()
	{
		
		$results = array();
		$items_to_remove = array();
		foreach(WC()->cart->get_cart() as $cart_key => $item)
		{
			$result = $this->customer_can_purchase_product($item['product_id'], $item['variation_id'], $item['quantity']);
			$results[] = $result;
			if(!$result['result'])
				$items_to_remove[] = $cart_key;
		}
		
		foreach((array)$items_to_remove as $item_key_to_remove)
			WC()->cart->remove_cart_item( $item_key_to_remove );
				
		return $results;
	}
	public function is_deposit_system_active($product_id)
	{
		$data = $this->get_presale_data($product_id, true);
		if(isset($data) && isset($data['data']['deposit_managment_active']))
			return $data['data']['deposit_managment_active'];
		return false;
	}
	public function is_a_deposit_deduction_coupon($code)
	{
		global $wpdb;
		$query = "SELECT order_item.order_id, order_itemmeta.order_item_id
				  FROM {$wpdb->woocommerce_order_items} as order_item
				  INNER JOIN {$wpdb->woocommerce_order_itemmeta} as order_itemmeta
				  WHERE order_itemmeta.meta_value = '{$code}' ";
		$order_data = $wpdb->get_results($query);
		$order_data = isset($order_data) && isset($order_data[0]) ? $order_data[0] : false;
		if($order_data)
		{
			$order = new WC_Order($order_data->order_id);
			foreach ( $order->get_items() as $order_item_id => $item ) 
			{
				if($order_item_id == $order_data->order_item_id)
				
					return $item['product_id'];
				
			}
		}
			
		return -1;
	}
	public function is_presale_active($product_id)
	{
		$presale_data = $this->get_presale_data($product_id, true);
		
		if(!isset($presale_data['data']))
			return false;
		if(isset($this->is_presale_active[$product_id])) 
			return $this->is_presale_active[$product_id];
		
		
		$is_active = isset($presale_data['data']['presale_active']) ? true : false;
		$result = false;
		$this->has_ended = false;
		  
		if($is_active)
		{
			$result = $this->check_activation_data($presale_data['data'], $product_id);
			$is_active = $result['is_active'];
			//unpublishing check 
			$this->has_ended = $result['is_period_ended'];
			if($result['is_period_ended'] &&  $result['unpublish'])
				$this->change_status($product_id);
			elseif($result['is_period_started'] )
				$this->change_status($product_id , 'publish');
		}
		$this->is_presale_active[$product_id] = $is_active;
		return $is_active;
	}
	public function get_presale_periods_info($product_id)
	{
		$presale_data = $this->get_presale_data($product_id, true);
		if(isset($presale_data))
		 return $this->check_activation_data($presale_data['data'], $product_id);
	 
		return false;
	}
	public function check_bulk_presale_activation_or_deactivation($products)
	{
		global $wcps_option_model;
		$products_to_activate_deactivate = [];
		foreach($products as $product)
		{
			/* Format
			object(stdClass)#537 (2) {
				["id"]=>
				string(2) "59"
				["presale_data"]=>
				string(426) "a:12:{s:14:"presale_active";s:2:"on"; ...}"
			  }
				*/
			$product->presale_data = unserialize($product->presale_data);
			$product_id = $product->id;
			
			if(isset($product->presale_data))
			{
				$is_active = isset($product->presale_data['presale_active']) ? true : false;
				if($is_active)
				{
					$result = $this->check_activation_data($product->presale_data, $product_id);
					$is_active = $result['is_active'];
					if($result['is_period_ended'] &&  $result['unpublish']/* $result['end_strategy'] != false */)
					{
						if(!$wcps_option_model->get_option('expired_product_still_visible'))
							$products_to_activate_deactivate['draft'][]  = $product_id;
					}
					elseif($result['is_period_started'] )
						$products_to_activate_deactivate['publish'][] = $product_id; 
				}
				
			}
		}
		//wcps_var_dump($products_to_activate_deactivate);
		$this->change_bulk_status($products_to_activate_deactivate);
	}
	private function check_activation_data($presale_data, $product_id)
	{
		global $wcps_option_model;
		$is_active = true;
		$threshold = isset($presale_data['threshold']) ? (int)$presale_data['threshold'] : 0;
		$is_period_ended = false;
		$is_period_started = false;
		$end_strategy = isset($presale_data['end_period_strategy']) ? $presale_data['end_period_strategy'] : false;
		$is_threshold_exceeded_after_date = 0;
		$expiring_datetime = isset($presale_data['expiring_date']) && strlen($presale_data['expiring_date']) > 2 ? $presale_data['expiring_date'] : false;
		$start_datetime = isset($presale_data['start_date']) && strlen($presale_data['start_date']) > 2 ? $presale_data['start_date'] : false;
		$time_offset = $wcps_option_model->get_option('time_offset');
		$is_presale_system_active = isset($presale_data['presale_active']) && $presale_data['presale_active'] ? $presale_data['presale_active'] : false;
		$automatic_presale_option_disable = isset($presale_data['automatic_presale_option_disable']) ? $presale_data['automatic_presale_option_disable'] : false;
		$unpublish = false;
		$going_to_activate = false;
		
		if($expiring_datetime)
			$expiring_datetime .= isset($presale_data['expiring_time']) && strlen($presale_data['expiring_time']) > 2 ? ' '.$presale_data['expiring_time'] : ' 23:59';
		if($start_datetime)
			$start_datetime .= isset($presale_data['start_time']) && strlen($presale_data['start_time']) > 2 ? ' '.$presale_data['start_time'] : ' 00:00';
					
		//expiring date
		$now =  DateTime::createFromFormat('Y/m/d H:i', date('Y/m/d H:i',strtotime($time_offset.' minutes')) ); 
		if($expiring_datetime != false)
			$expiring_datetime = DateTime::createFromFormat('Y/m/d H:i',$expiring_datetime); 
		if($start_datetime != false)
			$start_datetime = DateTime::createFromFormat('Y/m/d H:i',$start_datetime); 

		$total_sales = $this->get_total_sales($product_id); 
		
		//Start date check
		if( ($start_datetime != false && $now >= $start_datetime && $now < $expiring_datetime) ||
		($expiring_datetime == false  && $start_datetime != false && $now >= $start_datetime) )
		{
			$is_period_started = true;
		} 
		else if($start_datetime != false && $now < $start_datetime)
		{
			$going_to_activate = true;
			$is_active = false;
		}
		
		//End date check
		if($expiring_datetime != false && $now >= $expiring_datetime  )
		{
			$is_active = false;
			$is_period_ended = true;
			if($end_strategy == 'unpublish')
				$unpublish = true;
		}
		
		if($threshold != 0 && ( (!$is_period_ended && $total_sales >= $threshold && $end_strategy == 'unpublish_if_date_threshold_passed') 
							|| ($is_period_ended && $total_sales <= $threshold && $end_strategy == 'unpublish_if_date_threshold_not_passed') 
							|| ($total_sales >= $threshold && $end_strategy == 'threshold_limit_passed')   ))
		{
			$is_active = false;
			$is_period_ended = true;
			$is_period_started = false;
			$unpublish = true;
			
		}
		if($total_sales >= $threshold && $end_strategy == 'special_price_before_threshold')
		{
			$is_active = false;
			$unpublish = false;
			$is_period_ended = true;
		}
		
		if($is_period_ended && $automatic_presale_option_disable)
		{
			$presale_data['presale_active'] = false;
			$this->save_option( $product_id, 'wcps_data', $presale_data);
		}
		
		return array('is_expired' => $this->is_expired($product_id), 
					  'is_presale_system_active'=>$is_presale_system_active, 
					  'automatic_presale_option_disable'=> $automatic_presale_option_disable, 
					  'is_period_ended' =>$is_period_ended , 
					  'is_period_started' =>$is_period_started ,
					  'end_strategy'=>$end_strategy, 
					  'unpublish' => $unpublish,
					  'is_active' =>$is_active, 
					  'going_to_activate' => $going_to_activate);
	}
	public function check_products_to_show_or_hide_after_presale()
	{
		if($this->check_products_to_show_or_hide_after_presale_already_done)
			return;
		
		$this->check_products_to_show_or_hide_after_presale_already_done = true;
		$products = $this->get_product_ids_with_presale_active();
		//ToDo: improve. This could slow down the system
		/* foreach($products_ids as $id)
			$this->is_presale_active($id); */
			
		//echo mb_strlen($products[0]->presale_data, '8bit');
		$this->check_bulk_presale_activation_or_deactivation($products);
	}
}
?>