"use strict";

var wcps_per_page = 80;
var wcps_sleep_time = 500;
var wcps_current_iteration_num = 1;
var wcps_row_counter = 0;
var wcps_max_iterations = 0;
var wcps_picker_start_date;
var wcps_start_date;
var wcps_picker_end_date;
var wcps_end_date;
var wcps_customer_ids;
var wcps_product_ids;
var wcps_product_category_ids;
var wcps_csv_separator;
var wcps_csv_line_breaker;
var wcps_statuses = [];
var wcps_orders = {};
var wcps_orders_id = [];
				
jQuery(document).ready(function()
{
	
	jQuery("#column_to_export_ids").select2({});
	jQuery(document).on('click', "#select_all_button", wcps_select_uselect_column_checkboxes);
	wcps_picker_start_date =  jQuery( "#picker_start_date" ).pickadate({formatSubmit: 'yyyy/mm/dd'});
	wcps_picker_end_date = jQuery( "#picker_end_date" ).pickadate({formatSubmit: 'yyyy/mm/dd'});
	jQuery('#reload_button').fadeOut(0);
	
	jQuery(document).on('click','#start-export-button', wcps_start_exporting);
	jQuery(document).on('click', '#reload_button', function(){location.reload();});
	
	Date.prototype.yyyymmdd = function() {
	   var yyyy = this.getFullYear().toString();
	   var mm = (this.getMonth()+1).toString(); // getMonth() is zero-based
	   var dd  = this.getDate().toString();
	   return yyyy + (mm[1]?mm:"0"+mm[0]) + (dd[1]?dd:"0"+dd[0]); // padding
	};
});
function wcps_select_uselect_column_checkboxes()
{
	jQuery(".column_to_export_checkbox").prop("checked", !jQuery(".column_to_export_checkbox").prop("checked"));
}
function wcps_start_exporting()
{
	var picker_start_date = wcps_picker_start_date.pickadate('picker');
	var picker_end_date = wcps_picker_end_date.pickadate('picker'); 
	wcps_start_date = picker_start_date.get('select', 'yyyy-mm-dd'); 
	wcps_end_date = picker_end_date.get('select', 'yyyy-mm-dd');
	
	wcps_statuses = [];
	jQuery.each(jQuery('.status-checkbox'),function(index,value)
	{
		if(this.checked)
			wcps_statuses.push(jQuery(this).val());
	});
	
	wcps_row_counter = 0;
	if(wcps_statuses.length == 0)
		alert(wcps.statuses_error);
	else if(wcps_start_date > wcps_end_date)
		alert(wcps.date_error);
	else if(jQuery('#csv_separator').val() == "" )
	{
		alert(wcps.csv_error);
	}
	else
	{
		wcps_csv_separator = jQuery('#csv_separator').val(); 
		wcps_customer_ids = jQuery('#customer_ids').val();
		wcps_product_ids = jQuery('#product_ids').val();
		wcps_product_category_ids = jQuery('#category_ids').val();
		jQuery("html, body").animate({ scrollTop: 0 }, 800);
		jQuery('#option-box').delay('900').fadeOut('800');
		jQuery('#progress-container').delay('1800').fadeIn('800', wcps_get_order_tot);
	}
}

function wcps_get_order_tot()
{
	var formData = new FormData();
	formData.append('action', 'wcps_get_orders_tot_num');
	if(wcps_start_date != "")
		formData.append('start_date', wcps_start_date);
	if(wcps_end_date != "")
		formData.append('end_date', wcps_end_date);
	if(wcps_customer_ids)
		formData.append('customer_ids', wcps_customer_ids.join());
	if(wcps_product_ids)
		formData.append('product_ids', wcps_product_ids.join());
	if(wcps_product_category_ids)
		formData.append('category_ids', wcps_product_category_ids.join());
	formData.append('product_relationship', jQuery( "#product_relationship" ).val());
	formData.append('product_category_relationship', jQuery( "#product_category_relationship" ).val());
	formData.append('product_category_filters_relationship', jQuery( "#product_category_filters_relationship" ).val());
	formData.append('customer_product_category_filters_relationship', jQuery( "#customer_product_category_filters_relationship" ).val());
	formData.append('total_amount_spent_filter', jQuery( "#total_amount_spent_filter" ).val());
	formData.append('csv_separator', jQuery( "#csv_separator" ).val());
	formData.append('statuses', wcps_statuses.join());
	
	jQuery.ajax({
		url: ajaxurl, 
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) {
			wcps_max_iterations =  Math.ceil(data/wcps_per_page);
			wcps_get_orders_data();
		},
		error: function (data,error) 
		{
			alert("Could not contact the server, Error message: "+error);
			//wccm_check_response(data);
		},
		cache: false,
		contentType: false, 
		processData: false
	});
}
function wcps_get_orders_data()
{
	var formData = new FormData();
	formData.append('action', 'wcps_get_orders_data'); 
	if(wcps_start_date != "")
		formData.append('start_date', wcps_start_date);
	if(wcps_end_date != "")
		formData.append('end_date', wcps_end_date);
	if(wcps_customer_ids)
		formData.append('customer_ids', wcps_customer_ids.join());
	if(wcps_product_ids)
		formData.append('product_ids', wcps_product_ids.join());
	if(wcps_product_category_ids)
		formData.append('category_ids', wcps_product_category_ids.join());
	formData.append('product_relationship', jQuery( "#product_relationship" ).val());
	formData.append('product_category_relationship', jQuery( "#product_category_relationship" ).val());
	formData.append('product_category_filters_relationship', jQuery( "#product_category_filters_relationship" ).val());
	formData.append('customer_product_category_filters_relationship', jQuery( "#customer_product_category_filters_relationship" ).val());
	formData.append('total_amount_spent_filter', jQuery( "#total_amount_spent_filter" ).val());
	formData.append('csv_separator', jQuery( "#csv_separator" ).val());
	formData.append('statuses', wcps_statuses.join());	
	formData.append('per_page', wcps_per_page); 
	formData.append('page_num', wcps_current_iteration_num); 
	
	var perc_num = ((wcps_current_iteration_num/wcps_max_iterations)*100);
	perc_num = perc_num > 100 ? 100:perc_num;
	
	var perc = Math.floor(perc_num);
	jQuery('#ajax-progress').html("<p>computing data, please wait...<strong>"+perc+"% done</strong></p>");
	jQuery( "#progressbar" ).progressbar({
				  value: perc
				});
				
	jQuery.ajax({
		url: ajaxurl, //defined in php
		type: 'POST',
		data: formData,//{action: 'upload_csv', csv: data_to_send},
		async: true,
		success: function (data) {
			//alert(data);
			wcps_process_response_data(data);
		},
		error: function (data,error) 
		{
			if(wcps_per_page > 0)
			{
				wcps_per_page -= 10;
				wcps_get_orders_data();
			}
			else
				alert("Could not contact the server, Error message: "+error);
			//wccm_check_response(data);
		},
		cache: false,
		contentType: false,
		processData: false
	});
}
function wcps_process_response_data(data)
{
	if(data != null)
	{
		var result = jQuery.parseJSON(data);
		jQuery.each(result, function(index, value)
			{
				wcps_orders[wcps_row_counter] = value;
				wcps_row_counter++;
			});
	}
	if(wcps_current_iteration_num < wcps_max_iterations)
	{
		wcps_current_iteration_num++;
		setTimeout(function(){ wcps_get_orders_data(data); }, wcps_sleep_time);
	}
	else
	{
		var html_string = "";
			jQuery.each(wcps_orders, function( key, value_array )
				{
					wcps_orders_id.push(value_array.id);
					//id, order_date,billing_first_name,billing_last_name,billing_email
					html_string += '<tr class="guest-table-row">';
						html_string += '<td class="id column-id"><a href="'+wcps.admin_url+value_array.id+'&action=edit" target="_blank">'+value_array.id+'</a></td>';
						html_string += '<td class="date column-date">'+value_array.order_date+'</td>';
						html_string += '<td class="name column-name">'+value_array.billing_first_name+'</td>';
						html_string += '<td class="surname column-surname">'+value_array.billing_last_name+'</td>';
						html_string += '<td class="email column-email">'+value_array.billing_email+'</td>';
					html_string += '</tr>';
				});  
				
				
			window.location.replace(wcps.admin_url+"&wcps_order_ids="+wcps_orders_id.join()+"&wcps_is_search_orders_by_id=true");
			return;
			
			//No longer used, in new version the user is redirect to the filter Order list page	
			jQuery("#table-body").html(html_string);
			jQuery('#orders-table').DataTable( {
						"pagingType": "full_numbers",
						 "pageLength": 50,
						 "order": [[ 0, "desc" ]], //asc
						 "aoColumnDefs": [
							  { 'bSortable': false/*  , 'aTargets': [ 0,1 ] */ }
						   ]
					} );
			jQuery("#orders-table").fadeIn(800);
			jQuery( "#progressbar" ).progressbar({
			  value: 100
			});
			
			jQuery('#ajax-progress').append("<p>100% done</p> <h3>end!</h3>");
			jQuery('#progress-container').delay(200).fadeOut(800);
			jQuery('#wcps-order-list').delay(1000).fadeIn(800);
			jQuery('#reload_button').delay(1000).fadeIn(800);
	}
}
